Summary: A system for dynamic internet overlay deployment and management. 
Name: XBone
Version: 1.3
Release: 1
Copyright: XBone
Group: Networking/
Source0: http://www.isi.edu/x-bone/software/x-bone/XBone-1.3.tar.gz
Url: http://www.isi.edu/x-bone
BuildRoot: /var/tmp/XBone-buildroot/
Requires: perl >= 5.00503, perl-Mail-Sendmail, perl-File-CounterFile, perl-Net-Netmask
Provides: XBone <= 1.3
AutoReqProv: no
Prefix: /usr/local

%description
X-Bone dynamically deploys and manages Internet overlays to reduce their configuration effort and increase network component sharing. X-Bone discovers, configures, and monitors network resources to create overlays over existing IP networks. 
X-Bone uses two-layer IP in IP tunneled overlays and supports existing applications and unmodified routing, multicast, and DNS services in unmodified operating systems. X-Bone also support IPSec within overlays.

%prep
%setup

# There is really no "build" since X-Bone is written completely in Perl.
%build
echo "==> Installing XBone-1.3."

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/local
mkdir -p $RPM_BUILD_ROOT/usr/local/bin
#mkdir -p $RPM_BUILD_ROOT/usr/local/man
make PREFIX=$RPM_BUILD_ROOT/usr/local copyfile
rm -rf $RPM_BUILD_ROOT/usr/local/bin

%clean 
#rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root) 
/usr/local/xbone
/usr/local/man/man1/xb-pick.1
/usr/local/man/man5/XB_Defs.pm.5
/usr/local/man/man5/Xbone_daemon.conf.5
/usr/local/man/man5/Xbone_daemon.state.5
/usr/local/man/man8/X-Bone.8
/usr/local/man/man8/xb-config.8
/usr/local/man/man8/xb-daemon.8
/usr/local/man/man8/xb-overlay-manager.8

# %pre: check/process possible remaining certificates & conf/state files 
%pre
echo "==> XBone-1.3-1 Pre-Installation Script"
mkdir -p /etc/xbone/cert
if [ -d /usr/local/xbone ]; then
  echo "    - Found /usr/local/xbone. Process old certificates."
  for f in /usr/local/xbone/om/cert    /usr/local/xbone/rd/cert \
           /usr/local/www/server-cert  /usr/local/www/cert;  do
    if [ -d $f ]; then
      cp -fR $f/* /etc/xbone/cert
      rm -fR $f
    fi
  done
fi
if [ -f /etc/Xbone_daemon.state ]; then
  echo "    - Process old daemon state file."
  mv -f /etc/Xbone_daemon.state* /etc/xbone
fi
if [ -f /etc/Xbone_daemon.conf ]; then
  echo "    - Process old daemon conf file."
  perl -pe 's/=cert/=\/etc\/xbone\/cert/g' < /etc/Xbone_daemon.conf \
    > /etc/xbone/Xbone_daemon.conf
  rm -f /etc/Xbone_daemon.conf
fi
echo "<== XBone-1.3 Pre-Installation Script"

# %post: copy CAcert files, make symlinks for executables
%post
cp -R /usr/local/xbone/lib/cert/CAcert* /etc/xbone/cert
ln -fs /usr/local/xbone/om/xb-overlay-manager.pl \
       /usr/local/bin/xb-overlay-manager
ln -fs /usr/local/xbone/rd/xb-daemon.pl /usr/local/bin/xb-daemon
ln -fs /usr/local/xbone/rd/apps/xb-config.pl /usr/local/bin/xb-config
ln -fs /usr/local/xbone/rd/apps/xb-pick /usr/local/bin/xb-pick
echo " **********************************************************************"
echo " * >> XBone 1.3 core files installation completes!                    *"
echo " *    Please go to /usr/local/xbone/install and run the configuration *"
echo " *    script to finish the installation.                              *"
echo " *  > To configure host as XBone Resource Daemon:                     *"
echo " *      % make rpm-rd                                                 *"
echo " *  > To configure host as XBone Overlay Manager, XBone GUI, & DNS:   *"
echo " *      % make rpm-om SRC=/usr/local/xbone                            *"
echo " **********************************************************************"

# %preun: delete *.ORIG & symlink files originally not in the RPM
%preun
rm -f /usr/local/xbone/install/apache_conf_sample/httpsd.conf.ORIG
rm -f /usr/local/xbone/install/named_conf_sample/xbone/xbone.private.ORIG
rm -f /usr/local/xbone/install/named_conf_sample/xbone/xbone-reverse.private.ORIG
rm -f /usr/local/xbone/install/named_conf_sample/named.conf.ORIG
rm -f /usr/local/xbone/install/named_conf_sample/resolv.conf.ORIG
rm -f /usr/local/xbone/install/named_conf_sample/named.conf.bak
rm -f /usr/local/xbone/lib/XB_Defs.pm.ORIG
rm -f /usr/local/xbone/rd/apps/xb-config.pl.ORIG
rm -f /usr/local/xbone/rd/xb-daemon.pl.ORIG
rm -f /usr/local/xbone/www/cgi-bin/xb-get-ca-cert.pl.ORIG
rm -f /usr/local/xbone/www/cgi-bin/xb-req-user-cert.pl.ORIG
rm -f /usr/local/xbone/www/cgi-bin/index.pl.ORIG
rm -f /usr/local/xbone/www/s-cgi-bin/XB_Interface.pm.ORIG
rm -f /usr/local/xbone/www/s-cgi-bin/xb-admin.pl.ORIG
rm -f /usr/local/xbone/www/s-cgi-bin/xb-cookies.pl.ORIG
rm -f /usr/local/xbone/www/s-cgi-bin/xb-create.pl.ORIG
rm -f /usr/local/xbone/www/s-cgi-bin/xb-destroy.pl.ORIG
rm -f /usr/local/xbone/www/s-cgi-bin/xb-req-host-cert.pl.ORIG
rm -f /usr/local/xbone/www/s-cgi-bin/xb-status.pl.ORIG
rm -f /usr/local/xbone/www/s-cgi-bin/index.pl.ORIG
rm -f /usr/local/bin/xb-overlay-manager
rm -f /usr/local/bin/xb-daemon
rm -f /usr/local/bin/xb-config
rm -f /usr/local/bin/xb-pick

# %postun: prompt user for deleting /usr/local/xbone & /etc/xbone
%postun
if [ -d /etc/xbone ]; then
  echo ">>> Warning: /etc/xbone still exists. Delete it manually."
fi
if [ -d /usr/local/xbone ]; then
  echo ">>> Warning: /usr/local/xbone still exists. Delete it manually."
fi
echo "==> Note: Please check /usr/local/www & /usr/local/etc/apache if you"
echo "          want to delete the XBone GUI files."

%changelog

